; 

    .686
    .mmx
    .MODEL FLAT,STDCALL
    OPTION CASEMAP:NONE

  
    include \masm32\include\windows.inc
    include \masm32\macros\timers.asm      
    include \masm32\macros\macros.asm    
    include \masm32\include\kernel32.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\msvcrt.inc
    include \masm32\include\shlwapi.inc

    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\msvcrt.lib
    includelib \masm32\lib\shlwapi.lib

    InStringL proto :DWORD, :DWORD
    finstr    PROTO :DWORD,:DWORD,:DWORD

; 

.data
    align 16
    Mainstr db "The time has come the walrus said to speak of many things,"
            db " of birds and bugs and ceiling wax, of cabbages and kings."
            db " And if the sea is boiling hot and whether pigs have wings  ",0

    Substr1  db " walrus ",0

    Substr2  db "ceiling wax",0

    Substr3  db "sea is boiling hot",0

    Substr4  db "",0

    mismatch db "billabone billabone billabone billabone billabone billabone billabone billabone billabone billabone "
             db "billabone billabone billabone billabone billabone billabone billabone billabone billabone billabone "
             db "billabone billabone billabone billabone billabone billabone billabone billabone billabong ",0

    mmword   db "billabong",0

    cl1 dd 0
    cl2 dd 0
    cl3 dd 0

    .code
start:

; 

    print "Source length = "
    print str$(len(OFFSET Mainstr)),13,10

    print "Mismatch length = "
    print str$(len(OFFSET mismatch)),13,10,13,10

    invoke finstr,1,addr mismatch,addr mmword
    print str$(eax)," finstr mismatch recovery",13,10
    invoke finstr,1,addr Mainstr,addr Substr1
    print str$(eax)," finstr short",13,10
    invoke finstr,1,addr Mainstr,addr Substr2
    print str$(eax)," finstr medium",13,10
    invoke finstr,1,addr Mainstr,addr Substr3
    print str$(eax)," finstr long",13,10
    invoke finstr,1,addr Mainstr,addr Substr4
    print str$(eax)," finstr end",13,10

 ;     inkey
 ;     invoke ExitProcess,0

    LOOP_COUNT EQU 1000000

  REPEAT 8

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,1,addr Mainstr,addr Substr1
    counter_end
    add cl2, eax

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr Mainstr,addr Substr1
    counter_end
    add cl3, eax
   
  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3

    print "----------------------",13,10
    print "Short Search",13,10
    print "----------------------",13,10
    print str$(cl2)," average finstr",13,10
    print str$(cl3)," average InStringL",13,10
    print "----------------------",13,10


  ; ***********************************************


    mov cl1, 0
    mov cl2, 0
    mov cl3, 0

  REPEAT 8

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,1,addr Mainstr,addr Substr2
    counter_end
    add cl2, eax

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr Mainstr,addr Substr2
    counter_end
    add cl3, eax
   
  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3

    print "----------------------",13,10
    print "Medium Search",13,10
    print "----------------------",13,10
    print str$(cl2)," average finstr",13,10
    print str$(cl3)," average InStringL",13,10
    print "----------------------",13,10

  ; ***********************************************

    mov cl1, 0
    mov cl2, 0
    mov cl3, 0

  REPEAT 8

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,1,addr Mainstr,addr Substr3
    counter_end
    add cl2, eax

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr Mainstr,addr Substr3
    counter_end
    add cl3, eax
   
  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3

    print "----------------------",13,10
    print "Long Search",13,10
    print "----------------------",13,10
    print str$(cl2)," average finstr",13,10
    print str$(cl3)," average InStringL",13,10
    print "----------------------",13,10

  ; ***********************************************

    mov cl1, 0
    mov cl2, 0
    mov cl3, 0

  REPEAT 8

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,1,addr Mainstr,addr Substr4
    counter_end
    add cl2, eax

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr Mainstr,addr Substr4
    counter_end
    add cl3, eax
   
  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3

    print "------------------------------------------",13,10
    print "Full Length search on high ANSI characters",13,10
    print "------------------------------------------",13,10
    print str$(cl2)," average finstr",13,10
    print str$(cl3)," average InStringL",13,10
    print "----------------------",13,10

  ; ***********************************************

    mov cl1, 0
    mov cl2, 0
    mov cl3, 0

  REPEAT 8

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,1,addr mismatch,addr mmword
    counter_end
    add cl2, eax

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr mismatch,addr mmword
    counter_end
    add cl3, eax
   
  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3

    print "----------------------",13,10
    print "Mismatch Recovery Test",13,10
    print "----------------------",13,10
    print str$(cl2)," average finstr",13,10
    print str$(cl3)," average InStringL",13,10
    print "----------------------",13,10

    inkey

invoke ExitProcess,0

; 
OPTION PROLOGUE:NONE			; turn it off
OPTION EPILOGUE:NONE			;
align 16						;
InStringL	proc lpSource:DWORD, lpPattern:DWORD
	mov		eax, [esp+1*4]		; eax-> lpSource
    mov		edx, [esp+2*4]		; edx->lpPattern
    movzx	ecx, byte ptr [edx] ; ecx->the 1st byte of substring
	mov		[esp+2*4], esi		; saving register esi
    imul	ecx, 1010101h       ; ecx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov		[esp+1*4], ebx		; saving register ebx
	lea		esi, [edx+1]		; esi->lp Pattern +1
BytesScan:						;
	mov		edx, ecx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
	xor		ebx, ebx			;
@@:								;
	xor		ecx, [eax]			;
	add		eax, 4				;              
	add		ecx, 0FEFEFEFFh		;   
    test	ecx, 080808080h		;   
	mov		ecx, edx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
  	je		@b					; 
								;
    cmp		[eax-4], dl			; dl ->1st byte of pattern
    lea		eax, [eax-3]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	jne		@b
@@:								; CMP rest  of strings
	add		bl,	 [esi]
	je		@found	
	sub		bl,	 [eax]
	jne		BytesScan
	add		bl,	 [esi+1]
	je		@found	
	sub		bl,	 [eax+1]
	jne		BytesScan
	add		bl,	 [esi+2]
	je		@found	
	sub		bl,	 [eax+2]
	jne		BytesScan
	add		bl,	 [esi+3]
	je		@found	
	sub		bl,	 [eax+3]
	jne		BytesScan	
	add		bl,	 [esi+4]
	je		@found	
	sub		bl,	 [eax+4]
	jne		BytesScan
	add		bl,	 [esi+5]
	je		@found	
	sub		bl,	 [eax+5]
	jne		BytesScan
	add		bl,	 [esi+6]
	je		@found	
	sub		bl,	 [eax+6]
	jne		BytesScan
	add		bl,	 [esi+7]
	je		@found	
	sub		bl,	 [eax+7]
	jne		BytesScan
	add		bl,	 [esi+8]
	je		@found	
	sub		bl,	 [eax+8]
	jne		BytesScan
	mov		edx, 8
@@:	
	add		bl,	 [esi+edx+1]
	je		@found	
	sub		bl,	 [eax+edx+1]
	jne		BytesScan
	add		bl,	 [esi+edx+2]
	je		@found	
	sub		bl,	 [eax+edx+2]
	jne		BytesScan
	add		bl,	 [esi+edx+3]
	je		@found	
	sub		bl,	 [eax+edx+3]
	jne		BytesScan
	add		bl,	 [esi+edx+4]
	je		@found	
	sub		bl,	 [eax+edx+4]
	jne		BytesScan
	add		edx, 4
	jne		@b
@found:	
	mov		ebx, [esp+1*4]	 
	cmp		eax, esi		
	mov		esi, [esp+2*4]	 
	sbb		ecx, ecx
	mov		edx, [esp]	 
	add		eax,  -1		
	add		esp, 3*4 
	and		eax, ecx		;eax-> address of 1st occurrence or 0->Not found   
	jmp		edx				;
InStringL	endp			;
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

 ; OPTION PROLOGUE:NONE 
 ; OPTION EPILOGUE:NONE 
 ; 
 ; align 16
 ; 
 ; finstr proc spos:DWORD,psrc:DWORD,patn:DWORD
 ; 
 ;   ; --------------------------
 ;   ; simplified faster InString algorithm.
 ;   ; --------------------------
 ;   ; arguments
 ;   ; ---------
 ;   ; 1 spos = 1 based index start offset in source address
 ;   ; 2 psrc = the source address to be searched
 ;   ; 3 patn = the address of the pattern to be searched for
 ;   ; --------------------------
 ;   ; return values
 ;   ; -------------
 ;   ; on match, 1 based index offset from start of source.
 ;   ; no match returns zero.
 ;   ; --------------------------
 ;   ; NOTE: The "spos" can be set past the end of the
 ;   ; source buffer which will generate an unhandled
 ;   ; exception. To address this potential problem with
 ;   ; sequential searches, the return value should be
 ;   ; incremented by ONE BYTE at a time which ensures
 ;   ; that the starting position "spos" never goes past
 ;   ; the end of the source buffer.
 ;   ; --------------------------
 ; 
 ;     .data?
 ;       align 16
 ;       _ebx dd ?
 ;       _esi dd ?
 ;       _edi dd ?
 ;       _ebp dd ?
 ;     .code
 ; 
 ;     mov _ebx, ebx
 ;     mov _esi, esi
 ;     mov _edi, edi
 ;     mov _ebp, ebp
 ; 
 ;     mov ebp, 1
 ;     mov edi, [esp+12]               ; patn
 ;     movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
 ;     mov esi, [esp+8]                ; psrc
 ;     add esi, [esp+4]                ; spos
 ;     sub esi, 5
 ; 
 ; ; --------------------
 ; 
 ;   align 16
 ;   scanloop:
 ;   REPEAT 16
 ;     add esi, 4
 ;     mov edx, [esi]
 ;     cmp dl, al
 ;     je setindex
 ;     cmp dh, al
 ;     je sip1
 ;     and dl, dh
 ;     jz no_match
 ;     mov edx, [esi+2]
 ;     cmp dl, al
 ;     je sip2
 ;     cmp dh, al
 ;     je sip3
 ;     and dl, dh
 ;     jz no_match
 ;   ENDM
 ;     jmp scanloop
 ; 
 ; ; --------------------
 ; 
 ;   sip3:
 ;     add esi, ebp
 ;   sip2:
 ;     add esi, ebp
 ;   sip1:
 ;     add esi, ebp
 ;   setindex:
 ;     mov ebx, 1
 ; 
 ; ; --------------------
 ; 
 ;   matchloop:
 ; 
 ;   REPEAT 15
 ;     add ebx, ebp
 ;     movzx edx, BYTE PTR [edi+ebx]
 ;     cmp dl, [esi+ebx]
 ;     jz match                        ; text match if patn terminator found
 ;     cmp ecx, edx                    ; test for match
 ;     jne scanloop
 ;   ENDM
 ; 
 ;     add ebx, ebp
 ;     movzx edx, BYTE PTR [edi+ebx]
 ;     cmp dl, [esi+ebx]
 ;     jz match
 ;     cmp ecx, edx
 ;     jne scanloop
 ;     jmp matchloop
 ; 
 ; 
 ; 
 ;  ;   matchloop:
 ;  ;   REPEAT 16
 ;  ;     movzx ecx, BYTE PTR [esi+ebx]
 ;  ;     movzx edx, BYTE PTR [edi+ebx]
 ;  ;     cmp ecx, edx
 ;  ;     jne mchtst
 ;  ; 
 ;  ;     movzx ecx, BYTE PTR [esi+ebx+1]
 ;  ;     movzx edx, BYTE PTR [edi+ebx+1]
 ;  ;     cmp ecx, edx
 ;  ;     jne mchtst
 ;  ; 
 ;  ;     movzx ecx, BYTE PTR [esi+ebx+2]
 ;  ;     movzx edx, BYTE PTR [edi+ebx+2]
 ;  ;     cmp ecx, edx
 ;  ;     jne mchtst
 ;  ; 
 ;  ;     movzx ecx, BYTE PTR [esi+ebx+3]
 ;  ;     movzx edx, BYTE PTR [edi+ebx+3]
 ;  ;     cmp ecx, edx
 ;  ;     jne mchtst
 ;  ; 
 ;  ;     add ebx, 4
 ;  ; 
 ;  ;     jmp matchloop
 ;  ;   ENDM
 ;  ; 
 ;  ;   mchtst:
 ;  ;     test edx, edx
 ;  ;     jnz scanloop
 ; 
 ; 
 ; ; --------------------
 ; 
 ;   match:
 ;     sub esi, [esp+8]                ; psrc
 ;     lea eax, [esi+1]
 ;     jmp cleanup
 ; 
 ;   no_match:
 ;     xor eax, eax
 ; 
 ;   cleanup:
 ;     mov ebx, _ebx
 ;     mov esi, _esi
 ;     mov edi, _edi
 ;     mov ebp, _ebp
 ; 
 ;     ret 12
 ; 
 ; finstr endp
 ; 
 ; OPTION PROLOGUE:PrologueDef 
 ; OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

finstr proc spos:DWORD,psrc:DWORD,patn:DWORD

  ; --------------------------
  ; simplified faster InString algorithm.
  ; --------------------------
  ; arguments
  ; ---------
  ; 1 spos = 1 based index start offset in source address
  ; 2 psrc = the source address to be searched
  ; 3 patn = the address of the pattern to be searched for
  ; --------------------------
  ; return values
  ; -------------
  ; on match, 1 based index offset from start of source.
  ; no match returns zero.
  ; --------------------------
  ; NOTE: The "spos" can be set past the end of the
  ; source buffer which will generate an unhandled
  ; exception. To address this potential problem with
  ; sequential searches, the return value should be
  ; incremented by ONE BYTE at a time which ensures
  ; that the starting position "spos" never goes past
  ; the end of the source buffer.
  ; --------------------------

    .data?
      align 16
      _ebx dd ?
      _esi dd ?
      _edi dd ?
      _ebp dd ?
      _esp dd ?
    .code

    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+12]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+8]                ; psrc
    ;;; add esi, [esp+4]                ; spos
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1

; --------------------

  scanloop:
  REPEAT 16
  ; ----------------------------------------------
  ; test if the next 4 bytes contain an ascii zero
  ; ----------------------------------------------
    add esi, 4
    mov edx, [esi]
    lea ecx, [edx-01010101h]
    not edx
    and ecx, esp        ; modify ECX
    test ecx, edx       ; test with no modify
    jnz no_match
  ; ----------------------------------------
  ; test each byte for a patn 1st char match
  ; ----------------------------------------
    movzx ebx, BYTE PTR [esi]
    sub ebx, eax
    jz si0
    movzx ecx, BYTE PTR [esi+1]
    sub ecx, eax
    jz si1
    movzx edx, BYTE PTR [esi+2]
    sub edx, eax
    jz si2
    movzx ecx, BYTE PTR [esi+3]
    sub ecx, eax
    jz si3
  ENDM
    jmp scanloop

; --------------------

  si3:
    add esi, ebp
  si2:
    add esi, ebp
  si1:
    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 8
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    sub esi, [esp+8]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 12

finstr endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start

